#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# Author: Chris Oliver (excid3@gmail.com)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

# Import commands here, even though we don't use it because debian.py uses it
# and our plugin system confuses pyinstaller. We need to manually specify this
# in Keryx so that pyinstaller can grab it and bundle the code

import sys

from lib import config, log

# Handle translations
import gettext
import locale

_ = gettext.gettext
gettext.install(config.name.lower(), config.locale_dir)

lang, encoding = locale.getdefaultlocale()

try:
    lang = gettext.translation(config.name.lower(),
                               config.locale_dir,
                               languages=[lang])
    lang.install()
except FileNotFoundError:
    print(_('Could not locate a translation file for your language.'))

# TODO: Set wxWidgets translation information
 
# Parse arguments
if ('--version' in sys.argv) or ('-v' in sys.argv):
    log.info('%s %s' % (config.name, config.version))
    sys.exit(0)

if not hasattr(sys, 'frozen'):  # If this isn't a compiled version of Keryx...
    import wx
    app = wx.App()
    app.MainLoop()

# Attempt to load interface
from lib import wxkeryx
wxkeryx.start()
